% Code by Anna Choromanska and Tony Jebara
% Reference: T. Jebara and A. Choromanska, "Majorization for CRFs and Latent Likelihoods", Neural Information Processing Systems (NIPS), December 2012. 

function [RESULT_CELL] = data_processing(maxiter,file_now,iteration)
    global flag_BFGS;
    global flag_SD;
    global flag_CG;
    global flag_NEWTON_v1;
    global flag_BOUND_xi1_Mex_v2;

    %Loading results
    s=sprintf('Latent_STOPPER%d.%d.mat',file_now,iteration); load(s);
    s=sprintf('Latent%d.%d.mat',file_now,iteration); load(s);

    FINAL_TAB = [];

    i = 1;
    RESULT_CELL{i} = RESULT_BFGS;
    
    if(flag_SD == 1)
        i = i + 1;
        RESULT_CELL{i} = RESULT_SD;
    end
    if(flag_CG == 1)
        i = i + 1;
        RESULT_CELL{i} = RESULT_CG;
    end
    if(flag_NEWTON_v1 == 1)
        i = i + 1;
        RESULT_CELL{i} = RESULT_NEWTON_v1;
    end
    if(flag_BOUND_xi1_Mex_v2 == 1)
        i = i + 1;
        RESULT_CELL{i} = RESULT_BOUND_xi1_Mex_v2;
    end
    
    %----------------------------------------------------------------------
    %Cutting the tables to maxiter iterations
    for i = 1:1:size(RESULT_CELL,2) - 1
        RESULT_CELL{i} = RESULT_CELL{i}(1:min(maxiter,size(RESULT_CELL{i},1)),:);
    end
    %----------------------------------------------------------------------
end