% Code by Anna Choromanska and Tony Jebara
% Reference: T. Jebara and A. Choromanska, "Majorization for CRFs and Latent Likelihoods", Neural Information Processing Systems (NIPS), December 2012. 

function [zi,ui] = latent(theta)

global T;
global M;
global Y;
global F;
global YY;
global dims;
global latenttab;
global LAMBDA;
global flag_alg_on;

if(flag_alg_on == 1)
    save('RESULT_BFGS.mat','latenttab');
elseif(flag_alg_on == 2)
    save('RESULT_SD.mat','latenttab');
elseif(flag_alg_on == 3)
    save('RESULT_CG.mat','latenttab');
end

u = zeros(dims,1);
den = 0;
num = 0;
for t=1:T
    ztmy = 1e-200;
    utmy = zeros(dims,1);
    ztm = 1e-200;
    utm = zeros(dims,1);
    for m=1:M
        for y=1:Y
            fi = F{t,y,m};
            ai = exp(dot(theta,fi));
            utmy = utmy + ai*fi;
            ztmy = ztmy + ai;
        end
    end
    utmy = utmy/ztmy;
    
    for m=1:M
        fi = F{t,YY(t),m};
        ai = exp(dot(theta,fi));
        utm = utm + ai*fi;
        ztm = ztm + ai;
    end
    utm = utm/ztm;
    
    u = u + utmy - utm;
    u = u + LAMBDA*theta;
    num = num + log(ztm) - 0.5*LAMBDA*dot(theta,theta);
    den = den + log(ztmy);
end
zi = den-num;
ui = u;

% if(size(latenttab,1) > maxiter)
%     zi = logZtab(size(logZtab,1),1);
%     ui = zeros(d,1);
% end

if((zi > 1e300) || (isnan(zi)))
    zi = 1e300;
elseif(zi < -1e300)
    zi = -1e300;
end

latenttab = [latenttab;zi,cputime,theta'];

disp(size(latenttab,1));


    
   