% Code by Anna Choromanska and Tony Jebara
% Reference: T. Jebara and A. Choromanska, "Majorization for CRFs and Latent Likelihoods", Neural Information Processing Systems (NIPS), December 2012. 

function [zi] = testing_likelihood(theta,XX_t,YY_t,YY)

global M;

LAMBDA = 0;

T=size(XX_t,1);
D=size(XX_t,2);
Y=length(unique(YY));
dims=(D+1)*M*Y;

F = cell(1,Y,M);
for t=1:T
    for y=1:Y
        for m=1:M
            F{t,y,m} = zeros((D+1)*M*Y,1);
        end
    end
end

for t=1:T
    for y=1:Y
        for m=1:M
            f=zeros((D+1)*M*Y,1);
            f( ((y-1)*M*(D+1) + (m-1)*(D+1))+1: (((y-1)*M*(D+1) + (m-1)*(D+1))+D+1) )=[XX_t(t,:)'; 1];
            F{t,y,m} = f;
        end
    end
end

u = zeros(dims,1);
den = 0;
num = 0;
for t=1:T
    ztmy = 1e-200;
    utmy = zeros(dims,1);
    ztm = 1e-200;
    utm = zeros(dims,1);
    for m=1:M
        for y=1:Y
            fi = F{t,y,m};
            ai = exp(dot(theta,fi));
            utmy = utmy + ai*fi;
            ztmy = ztmy + ai;
        end
    end
    utmy = utmy/ztmy;
    
    for m=1:M
        fi = F{t,YY_t(t),m};
        ai = exp(dot(theta,fi));
        utm = utm + ai*fi;
        ztm = ztm + ai;
    end
    utm = utm/ztm;
    
    u = u + utmy - utm;
    u = u;
    num = num + log(ztm);
    den = den + log(ztmy);
end
zi = den-num;
ui = u;

if((zi > 1e300) || (isnan(zi)))
    zi = 1e300;
elseif(zi < -1e300)
    zi = -1e300;
end
