% Code by Anna Choromanska and Tony Jebara
% Reference: T. Jebara and A. Choromanska, "Majorization for CRFs and Latent Likelihoods", Neural Information Processing Systems (NIPS), December 2012. 

function [value_time, value_iterations, value_convergence] = value_function(maxiter, likelihood, file_now, iteration)
    %Loading results
    s=sprintf('Latent_STOPPER%d.%d.mat',file_now,iteration); load(s);
    s=sprintf('Latent%d.%d.mat',file_now,iteration); load(s);

    %----------------------------------------------------------------------
    %Cutting the tables to maxiter iterations
    for i = 1:1:size(likelihood,2) - 1
        likelihood{i} = likelihood{i}(1:min(maxiter,size(likelihood{i},1)),:);
    end
    %----------------------------------------------------------------------
    
    if(RESULT_BFGS(size(RESULT_BFGS,1),1)) > STOPPER
        STOPPER = RESULT_BFGS(size(RESULT_BFGS,1),1);
    end
    
    %BFGS
    index = [];
    index = find(RESULT_BFGS(:,1) <= STOPPER);
    time_BFGS = RESULT_BFGS(index(1),2);
    iterations_BFGS = index(1);

    for i = 1:1:size(likelihood,2) 
        RESULT_TAB = [];
        RESULT_TAB = likelihood{i};
        value_iterations(i) = RESULT_TAB(min(iterations_BFGS,size(RESULT_TAB,1)),1);
        %----------------------------------------------------------------------
        index = [];
        index = find(RESULT_TAB >= time_BFGS);
        if((size(index,1) ~= 0) && (size(index,2) ~= 0))
            value_time(i) = RESULT_TAB(index(1));
        else      
            value_time(i) = RESULT_TAB(size(RESULT_TAB,1));
        end
        value_convergence(i) = RESULT_TAB(size(RESULT_TAB,1),1);
    end
end
